unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Spin;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    mmText: TMemo;
    Label1: TLabel;
    seN: TSpinEdit;
    Label2: TLabel;
    btEncode: TButton;
    btDecode: TButton;
    procedure btEncodeClick(Sender: TObject);
  private
    { Private declarations }
    procedure Encode(bCode: boolean; n: integer); // Encode - 
                                                  // bCode  - /
                                                  // n      -  
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//  
procedure TForm1.Encode(bCode: boolean; n: integer);
const
  sMsgRangeErr = '     %d  %d!';

  //    
  chBigFirstLetter: char = '';
  chBigLastLetter: char = '';

  chFirstLetter: char = '';
  chLastLetter: char = '';
var
  iMinOrd: integer; //     
  iMaxOrd: integer; //     
  i: integer; //  
  iTempOrd: integer; //   
  ch: char; //   
  s: string; //  
begin
  //      
  if (n > Ord(chBigLastLetter) - Ord(chBigFirstLetter)) or (n < 1) then
  begin
    MessageDlg(Format(sMsgRangeErr, [1, Ord(chBigLastLetter) - Ord(chBigFirstLetter)]), mtError, [mbOk], 0);
    Exit;
  end;

  s := Trim(mmText.Text);
  if s <> '' then //   
    for i := 1 to Length(s) do //   
    begin
      ch := s[i];

      //     
      if ch in [chBigFirstLetter .. chBigLastLetter] then //  
      begin
        iMinOrd := Ord(chBigFirstLetter);
        iMaxOrd := Ord(chBigLastLetter);
      end
      else
      if ch in [chFirstLetter .. chLastLetter] then //  
      begin
        iMinOrd := Ord(chFirstLetter);
        iMaxOrd := Ord(chLastLetter);
      end
      else //    
        continue;

      if bCode then // 
      begin
        iTempOrd := Ord(ch) + n; //   
        if iMaxOrd - iTempOrd < 0 then //      
          ch := Chr(iMinOrd + abs(iMaxOrd - iTempOrd) - 1) //      
        else //  ..
          ch := chr(iTempOrd); //.. 
      end
      else // 
      begin
        iTempOrd := Ord(ch) - n; //   
        if iMinOrd - iTempOrd > 0 then //      
          ch := Chr(iMaxOrd - (iMinOrd - iTempOrd - 1)) //      
        else //  ..
          ch := chr(iTempOrd); //.. 
      end;

      s[i] := ch;
    end;
  mmText.Text := s;
end;

procedure TForm1.btEncodeClick(Sender: TObject);
begin
  Encode(boolean((Sender as TButton).Tag), seN.Value);
end;

end.
